/**
 * @license
 * Copyright 2023-2025 Dynatrace LLC
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// packages/util/react-hooks/src/index.ts
var src_exports = {};
__export(src_exports, {
  DqlQueryParamsContext: () => DqlQueryParamsContext,
  DqlQueryParamsProvider: () => DqlQueryParamsProvider,
  useAccessorPermissionsV2: () => useAccessorPermissionsV2,
  useAllUsersPermissionsV2: () => useAllUsersPermissionsV2,
  useAnalyzer: () => useAnalyzer,
  useAppFunction: () => useAppFunction,
  useAppState: () => useAppState,
  useAppStates: () => useAppStates,
  useCreateDocument: () => useCreateDocument,
  useCreatePermissionsV2: () => useCreatePermissionsV2,
  useCreateSettings: () => useCreateSettings,
  useCreateSettingsV2: () => useCreateSettingsV2,
  useDeleteAccessorPermissionsV2: () => useDeleteAccessorPermissionsV2,
  useDeleteAllUsersPermissionsV2: () => useDeleteAllUsersPermissionsV2,
  useDeleteAppState: () => useDeleteAppState,
  useDeleteAppStates: () => useDeleteAppStates,
  useDeleteDocument: () => useDeleteDocument,
  useDeleteSettings: () => useDeleteSettings,
  useDeleteSettingsV2: () => useDeleteSettingsV2,
  useDeleteUserAppState: () => useDeleteUserAppState,
  useDeleteUserAppStates: () => useDeleteUserAppStates,
  useDocument: () => useDocument,
  useDocumentMetaData: () => useDocumentMetaData,
  useDownloadDocument: () => useDownloadDocument,
  useDql: () => useDql,
  useDqlQuery: () => useDqlQuery,
  useEffectivePermissions: () => useEffectivePermissions,
  useEffectivePermissionsV2: () => useEffectivePermissionsV2,
  useListDocuments: () => useListDocuments,
  usePermissionsV2: () => usePermissionsV2,
  useSetAppState: () => useSetAppState,
  useSetUserAppState: () => useSetUserAppState,
  useSettings: () => useSettings,
  useSettingsObjects: () => useSettingsObjects,
  useSettingsObjectsV2: () => useSettingsObjectsV2,
  useSettingsV2: () => useSettingsV2,
  useTransferOwnershipV2: () => useTransferOwnershipV2,
  useUpdateAccessorPermissionsV2: () => useUpdateAccessorPermissionsV2,
  useUpdateAllUsersPermissionsV2: () => useUpdateAllUsersPermissionsV2,
  useUpdateDocument: () => useUpdateDocument,
  useUpdateDocumentMetadata: () => useUpdateDocumentMetadata,
  useUpdateSettings: () => useUpdateSettings,
  useUpdateSettingsV2: () => useUpdateSettingsV2,
  useUserAppState: () => useUserAppState,
  useUserAppStates: () => useUserAppStates
});
module.exports = __toCommonJS(src_exports);

// packages/util/react-hooks/src/useAnalyzer.ts
var import_client_davis_analyzers = require("@dynatrace-sdk/client-davis-analyzers");

// packages/util/react-hooks/src/react-async-hook/react-async-hook.ts
var import_react = require("react");
var useIsomorphicLayoutEffect = typeof window !== "undefined" && typeof window.document !== "undefined" && typeof window.document.createElement !== "undefined" ? import_react.useLayoutEffect : import_react.useEffect;
var useGetter = (t) => {
  const ref = (0, import_react.useRef)(t);
  useIsomorphicLayoutEffect(() => {
    ref.current = t;
  });
  return (0, import_react.useCallback)(() => ref.current, [ref]);
};
var InitialAsyncState = {
  status: "not-requested",
  loading: false,
  result: void 0,
  error: void 0
};
var InitialAsyncLoadingState = {
  status: "loading",
  loading: true,
  result: void 0,
  error: void 0
};
var defaultSetLoading = (_asyncState) => InitialAsyncLoadingState;
var defaultSetResult = (result, _asyncState) => ({
  status: "success",
  loading: false,
  result,
  error: void 0
});
var defaultSetError = (error, _asyncState) => ({
  status: "error",
  loading: false,
  result: void 0,
  error
});
var noop = () => {
};
var DefaultOptions = {
  initialState: (options) => options && options.executeOnMount ? InitialAsyncLoadingState : InitialAsyncState,
  executeOnMount: true,
  executeOnUpdate: true,
  setLoading: defaultSetLoading,
  setResult: defaultSetResult,
  setError: defaultSetError,
  onSuccess: noop,
  onError: noop
};
var normalizeOptions = (options) => ({
  ...DefaultOptions,
  ...options
});
var useAsyncState = (options) => {
  const [value, setValue] = (0, import_react.useState)(() => options.initialState(options));
  const reset = (0, import_react.useCallback)(() => setValue(options.initialState(options)), [setValue, options]);
  const setLoading = (0, import_react.useCallback)(() => setValue(options.setLoading(value)), [value, setValue]);
  const setResult = (0, import_react.useCallback)(
    (result) => setValue(options.setResult(result, value)),
    [value, setValue]
  );
  const setError = (0, import_react.useCallback)(
    (error) => setValue(options.setError(error, value)),
    [value, setValue]
  );
  const merge = (0, import_react.useCallback)(
    (state) => setValue({
      ...value,
      ...state
    }),
    [value, setValue]
  );
  return {
    value,
    set: setValue,
    merge,
    reset,
    setLoading,
    setResult,
    setError
  };
};
var useIsMounted = () => {
  const ref = (0, import_react.useRef)(false);
  (0, import_react.useEffect)(() => {
    ref.current = true;
    return () => {
      ref.current = false;
    };
  }, []);
  return () => ref.current;
};
var useCurrentPromise = () => {
  const ref = (0, import_react.useRef)(null);
  return {
    set: (promise) => ref.current = promise,
    get: () => ref.current,
    is: (promise) => ref.current === promise
  };
};
var useAsyncInternal = (asyncFunction, params, options) => {
  !params && (params = []);
  const normalizedOptions = normalizeOptions(options);
  const [currentParams, setCurrentParams] = (0, import_react.useState)(null);
  const AsyncState = useAsyncState(normalizedOptions);
  const isMounted = useIsMounted();
  const CurrentPromise = useCurrentPromise();
  const shouldHandlePromise = (p) => isMounted() && CurrentPromise.is(p);
  const executeAsyncOperation = (...args) => {
    const promise = (async () => asyncFunction(...args))();
    setCurrentParams(args);
    CurrentPromise.set(promise);
    AsyncState.setLoading();
    promise.then(
      (result) => {
        if (shouldHandlePromise(promise)) {
          AsyncState.setResult(result);
        }
        normalizedOptions.onSuccess(result, {
          isCurrent: () => CurrentPromise.is(promise)
        });
      },
      (error) => {
        if (shouldHandlePromise(promise)) {
          AsyncState.setError(error);
        }
        normalizedOptions.onError(error, {
          isCurrent: () => CurrentPromise.is(promise)
        });
      }
    );
    return promise;
  };
  const getLatestExecuteAsyncOperation = useGetter(executeAsyncOperation);
  const executeAsyncOperationMemo = (0, import_react.useCallback)(
    (...args) => {
      try {
        return getLatestExecuteAsyncOperation()(...args);
      } catch (e) {
        return Promise.resolve(void 0);
      }
    },
    [getLatestExecuteAsyncOperation]
  );
  const isMounting = !isMounted();
  (0, import_react.useEffect)(() => {
    const execute = () => getLatestExecuteAsyncOperation()(...params);
    isMounting && normalizedOptions.executeOnMount && execute();
    !isMounting && normalizedOptions.executeOnUpdate && execute();
  }, params);
  return {
    ...AsyncState.value,
    set: AsyncState.set,
    merge: AsyncState.merge,
    reset: AsyncState.reset,
    execute: executeAsyncOperationMemo,
    currentPromise: CurrentPromise.get(),
    currentParams
  };
};
function useAsync(asyncFunction, params, options) {
  return useAsyncInternal(asyncFunction, params, options);
}
var useAsyncAbortable = (asyncFunction, params, options) => {
  const abortControllerRef = (0, import_react.useRef)();
  const asyncFunctionWrapper = async (...p) => {
    if (abortControllerRef.current) {
      abortControllerRef.current.abort();
    }
    const abortController = new AbortController();
    abortControllerRef.current = abortController;
    try {
      return await asyncFunction(abortController.signal, ...p);
    } finally {
      if (abortControllerRef.current === abortController) {
        abortControllerRef.current = void 0;
      }
    }
  };
  return {
    ...useAsync(asyncFunctionWrapper, params, options),
    cancel: () => abortControllerRef?.current?.abort()
  };
};
var useAsyncCallback = (asyncFunction, options) => {
  return useAsyncInternal(
    asyncFunction,
    // Hacky but in such case we don't need the params,
    // because async function is only executed manually
    [],
    {
      ...options,
      executeOnMount: false,
      executeOnUpdate: false
    }
  );
};

// packages/util/react-hooks/src/util/delay-util.ts
var delay = (ms, value, signal) => new Promise((resolve, reject) => {
  const listener = () => {
    clearTimeout(timer);
    reject(value);
  };
  const timer = setTimeout(() => {
    signal?.removeEventListener("abort", listener);
    resolve(value);
  }, ms);
  signal?.addEventListener("abort", listener);
});

// packages/util/react-hooks/src/useAnalyzer.ts
var useAnalyzer = (params, options = { autoFetch: true, autoFetchOnUpdate: true }) => {
  const onError = typeof options.onError === "function" ? options.onError : () => void 0;
  const result = useAsyncAbortable(
    (signal) => doExecute(params, signal),
    [JSON.stringify(params)],
    {
      executeOnMount: options.autoFetch,
      executeOnUpdate: options.autoFetchOnUpdate,
      onError
    }
  );
  return getResult(result);
};
var doExecute = async (params, abortSignal) => {
  const executeResult = await import_client_davis_analyzers.analyzersClient.executeAnalyzer({ ...params, abortSignal });
  if (executeResult.result.executionStatus === "COMPLETED") {
    return executeResult.result;
  }
  let pollResult = null;
  while (executeResult.requestToken && (pollResult === null || pollResult.result.executionStatus === "RUNNING")) {
    try {
      await delay(1e3, null, abortSignal);
      pollResult = await import_client_davis_analyzers.analyzersClient.pollAnalyzerExecution({
        analyzerName: params.analyzerName,
        requestToken: executeResult.requestToken,
        abortSignal
      });
    } finally {
      await abortAnalyzer(abortSignal, params.analyzerName, executeResult.requestToken);
    }
  }
  return pollResult?.result;
};
var getResult = (result) => {
  let error = result.error;
  if (result.error?.name === "AbortError")
    error = void 0;
  return {
    data: result.result,
    error: result.error,
    errorDetails: error?.body?.error,
    isError: error ? true : false,
    isLoading: result.loading,
    isSuccess: !error && !result.loading && result.result,
    status: result.status,
    refetch: result.execute,
    cancel: result.cancel
  };
};
var abortAnalyzer = async function(signal, analyzerName, requestToken) {
  if (signal?.aborted) {
    await import_client_davis_analyzers.analyzersClient.cancelAnalyzerExecution({
      analyzerName,
      requestToken
    });
    return Promise.reject();
  }
};

// packages/util/react-hooks/src/useAppState.ts
var import_client_state = require("@dynatrace-sdk/client-state");
var import_react2 = require("react");
function useAppState(params, options = { autoFetch: true, autoFetchOnUpdate: true }) {
  const onError = typeof options.onError === "function" ? options.onError : () => void 0;
  const result = useAsyncAbortable(
    (signal) => {
      return import_client_state.stateClient.getAppState({ ...params, abortSignal: signal });
    },
    [JSON.stringify(params)],
    {
      executeOnMount: options.autoFetch,
      executeOnUpdate: options.autoFetchOnUpdate,
      onError
    }
  );
  return getResult2(result);
}
function useAppStates(params, options = { autoFetch: true, autoFetchOnUpdate: true }) {
  const onError = typeof options.onError === "function" ? options.onError : () => void 0;
  const result = useAsyncAbortable(
    (signal) => import_client_state.stateClient.getAppStates({ ...params, abortSignal: signal }),
    [JSON.stringify(params)],
    {
      executeOnMount: options.autoFetch,
      executeOnUpdate: options.autoFetchOnUpdate,
      onError
    }
  );
  return getResult2(result);
}
function useUserAppState(params, options = { autoFetch: true, autoFetchOnUpdate: true }) {
  const onError = typeof options.onError === "function" ? options.onError : () => void 0;
  const result = useAsyncAbortable(
    (signal) => {
      return import_client_state.stateClient.getUserAppState({ ...params, abortSignal: signal });
    },
    [JSON.stringify(params)],
    {
      executeOnMount: options.autoFetch,
      executeOnUpdate: options.autoFetchOnUpdate,
      onError
    }
  );
  return getResult2(result);
}
function useUserAppStates(params, options = { autoFetch: true, autoFetchOnUpdate: true }) {
  const onError = typeof options.onError === "function" ? options.onError : () => void 0;
  const result = useAsyncAbortable(
    (signal) => import_client_state.stateClient.getUserAppStates({ ...params, abortSignal: signal }),
    [JSON.stringify(params)],
    {
      executeOnMount: options.autoFetch,
      executeOnUpdate: options.autoFetchOnUpdate,
      onError
    }
  );
  return getResult2(result);
}
function useDeleteAppState() {
  const execute = (0, import_react2.useCallback)(async (params) => {
    await result.execute(params);
  }, []);
  const result = useAsyncCallback((params) => import_client_state.stateClient.deleteAppState({ ...params }));
  return getCallbackResult(result, execute);
}
function useDeleteAppStates() {
  const result = useAsyncCallback(() => import_client_state.stateClient.deleteAppStates());
  return getCallbackResult(result, result.execute);
}
function useDeleteUserAppState() {
  const execute = (0, import_react2.useCallback)(async (params) => {
    await result.execute(params);
  }, []);
  const result = useAsyncCallback((params) => import_client_state.stateClient.deleteUserAppState({ ...params }));
  return getCallbackResult(result, execute);
}
function useDeleteUserAppStates() {
  const result = useAsyncCallback(() => import_client_state.stateClient.deleteUserAppStates());
  return getCallbackResult(result, result.execute);
}
function useSetAppState() {
  const execute = (0, import_react2.useCallback)(async (params) => {
    await result.execute(params);
  }, []);
  const result = useAsyncCallback(
    (params) => import_client_state.stateClient.setAppState({ ...params })
  );
  return getCallbackResult(result, execute);
}
function useSetUserAppState() {
  const execute = (0, import_react2.useCallback)(async (params) => {
    await result.execute(params);
  }, []);
  const result = useAsyncCallback(
    (params) => import_client_state.stateClient.setUserAppState({ ...params })
  );
  return getCallbackResult(result, execute);
}
function getCallbackResult(result, execute) {
  const error = result.error;
  return {
    execute,
    data: result.result,
    error: result.error,
    errorDetails: error?.body?.error,
    isError: error ? true : false,
    isSuccess: !error && !result.loading && result.result,
    isLoading: result.loading,
    status: result.status
  };
}
function getResult2(result) {
  const error = result.error;
  return {
    data: result.result,
    error: result.error,
    errorDetails: error?.body?.error,
    isError: error ? true : false,
    isLoading: result.loading,
    isSuccess: !error && !result.loading && result.result,
    status: result.status,
    refetch: result.execute,
    cancel: result.cancel
  };
}

// packages/util/react-hooks/src/useDocument.ts
var import_client_document = require("@dynatrace-sdk/client-document");
var import_react3 = require("react");
function useDocument(params, options = { autoFetch: true, autoFetchOnUpdate: true }) {
  const onError = typeof options.onError === "function" ? options.onError : () => void 0;
  const result = useAsyncAbortable(
    (signal) => import_client_document.documentsClient.getDocument({ ...params, abortSignal: signal }),
    [JSON.stringify(params)],
    {
      executeOnMount: options.autoFetch,
      executeOnUpdate: options.autoFetchOnUpdate,
      onError
    }
  );
  return getResult3(result);
}
function useDocumentMetaData(params, options = { autoFetch: true, autoFetchOnUpdate: true }) {
  const onError = typeof options.onError === "function" ? options.onError : () => void 0;
  const result = useAsyncAbortable(
    (signal) => import_client_document.documentsClient.getDocumentMetadata({
      ...params,
      abortSignal: signal
    }),
    [JSON.stringify(params)],
    {
      executeOnMount: options.autoFetch,
      executeOnUpdate: options.autoFetchOnUpdate,
      onError
    }
  );
  return getResult3(result);
}
function useListDocuments(params, options = { autoFetch: true, autoFetchOnUpdate: true }) {
  const onError = typeof options.onError === "function" ? options.onError : () => void 0;
  const result = useAsyncAbortable(
    async (signal) => import_client_document.documentsClient.listDocuments({ ...params, abortSignal: signal }),
    [JSON.stringify(params)],
    {
      executeOnMount: options.autoFetch,
      executeOnUpdate: options.autoFetchOnUpdate,
      onError
    }
  );
  return getResult3(result);
}
function useDownloadDocument(params, options = { autoFetch: true, autoFetchOnUpdate: true }) {
  const onError = typeof options.onError === "function" ? options.onError : () => void 0;
  const result = useAsyncAbortable(
    (signal) => import_client_document.documentsClient.downloadDocumentContent({ ...params, abortSignal: signal }),
    [JSON.stringify(params)],
    {
      executeOnMount: options.autoFetch,
      executeOnUpdate: options.autoFetchOnUpdate,
      onError
    }
  );
  return getResult3(result);
}
function useCreateDocument() {
  const executeParams = (0, import_react3.useRef)();
  const execute = async (params) => {
    executeParams.current = params;
    await result.execute();
  };
  const result = useAsyncCallback(() => {
    if (executeParams.current) {
      return import_client_document.documentsClient.createDocument({ ...executeParams.current });
    }
  });
  return getCallbackResult2(result, execute);
}
function useUpdateDocument() {
  const executeParams = (0, import_react3.useRef)();
  const execute = async (params) => {
    executeParams.current = params;
    await result.execute();
  };
  const result = useAsyncCallback(() => {
    if (executeParams.current) {
      return import_client_document.documentsClient.updateDocument({ ...executeParams.current });
    }
  });
  return getCallbackResult2(result, execute);
}
function useUpdateDocumentMetadata() {
  const executeParams = (0, import_react3.useRef)();
  const execute = async (params) => {
    executeParams.current = params;
    await result.execute();
  };
  const result = useAsyncCallback(() => {
    if (executeParams.current) {
      return import_client_document.documentsClient.updateDocumentMetadata({ ...executeParams.current });
    }
  });
  return getCallbackResult2(result, execute);
}
function useDeleteDocument() {
  const executeParams = (0, import_react3.useRef)();
  const execute = async (params) => {
    executeParams.current = params;
    await result.execute();
  };
  const result = useAsyncCallback(() => {
    if (executeParams.current) {
      return import_client_document.documentsClient.deleteDocument({ ...executeParams.current });
    }
  });
  return getCallbackResult2(result, execute);
}
function getCallbackResult2(result, execute) {
  const error = result.error;
  return {
    execute,
    data: result.result,
    error: result.error,
    errorDetails: error?.body?.error,
    isError: error ? true : false,
    isSuccess: !error && !result.loading && result.result,
    isLoading: result.loading,
    status: result.status
  };
}
function getResult3(result) {
  const error = result.error;
  return {
    data: result.result,
    error: result.error,
    errorDetails: error?.body?.error,
    isError: error ? true : false,
    isLoading: result.loading,
    isSuccess: !error && !result.loading && result.result,
    status: result.status,
    refetch: result.execute,
    cancel: result.cancel
  };
}

// packages/util/react-hooks/src/useDqlQuery.ts
var import_client_query = require("@dynatrace-sdk/client-query");
function useDqlQuery(params, options = { autoFetch: true, autoFetchOnUpdate: true }) {
  const onError = typeof options.onError === "function" ? options.onError : () => void 0;
  const result = useAsyncAbortable(
    (signal) => doQuery(params, signal),
    [JSON.stringify(params)],
    {
      executeOnMount: options.autoFetch,
      executeOnUpdate: options.autoFetchOnUpdate,
      onError
    }
  );
  let error = result.error;
  if (result.error?.name === "AbortError")
    error = void 0;
  return {
    data: result.result,
    error: error ? result.error : void 0,
    errorDetails: error?.body?.error,
    isError: error ? true : false,
    isLoading: result.loading,
    isSuccess: !error && !result.loading && !!result.result,
    status: result.status,
    refetch: result.execute,
    cancel: result.cancel
  };
}
var doQuery = async function(params, signal) {
  const executeResult = await import_client_query.queryExecutionClient.queryExecute({
    ...params,
    abortSignal: signal
  });
  if (!(executeResult.state === import_client_query.QueryState.Running || executeResult.state === import_client_query.QueryState.NotStarted || executeResult.result === void 0)) {
    return executeResult.result;
  }
  let queryResult = null;
  while (executeResult.requestToken && (queryResult === null || queryResult.state === import_client_query.QueryState.Running || queryResult.state === import_client_query.QueryState.NotStarted)) {
    try {
      await delay(1e3, null, signal);
    } finally {
      await abortQuery(signal, executeResult.requestToken);
    }
    try {
      queryResult = await import_client_query.queryExecutionClient.queryPoll({
        requestToken: executeResult.requestToken,
        enrich: params?.enrich,
        abortSignal: signal
      });
    } finally {
      await abortQuery(signal, executeResult.requestToken);
    }
  }
  return queryResult?.result;
};
var abortQuery = async function(signal, requestToken) {
  if (signal?.aborted) {
    await import_client_query.queryExecutionClient.queryCancel({
      requestToken
    });
    return Promise.reject();
  }
};

// packages/util/react-hooks/src/useAppFunction.ts
var import_app_utils = require("@dynatrace-sdk/app-utils");
function useAppFunction({ name, data, responseType = "json" }, options = { autoFetch: true, autoFetchOnUpdate: true }) {
  const onError = typeof options.onError === "function" ? options.onError : () => void 0;
  const result = useAsyncAbortable(
    (signal) => import_app_utils.functions.call(name, { data, abortSignal: signal }).then((res) => res[responseType]()),
    [JSON.stringify(data)],
    {
      executeOnMount: options.autoFetch,
      executeOnUpdate: options.autoFetchOnUpdate,
      onError
    }
  );
  return {
    data: result.result,
    error: result.error,
    isError: !!result.error,
    isLoading: result.loading,
    isSuccess: !result.error && !result.loading && !!result.result,
    status: result.status,
    refetch: result.execute,
    cancel: result.cancel
  };
}

// packages/util/react-hooks/src/useSettings.ts
var import_client_app_settings = require("@dynatrace-sdk/client-app-settings");
var import_react4 = require("react");
function useSettings(params, options = { autoFetch: true, autoFetchOnUpdate: true }) {
  const onError = typeof options.onError === "function" ? options.onError : () => void 0;
  const result = useAsyncAbortable(
    (signal) => {
      return import_client_app_settings.appSettingsObjectsClient.getEffectiveAppSettingsValues({
        ...params,
        abortSignal: signal
      });
    },
    [JSON.stringify(params)],
    {
      executeOnMount: options.autoFetch,
      executeOnUpdate: options.autoFetchOnUpdate,
      onError
    }
  );
  return getResult4(result);
}
function useSettingsObjects(params, options = { autoFetch: true, autoFetchOnUpdate: true }) {
  const onError = typeof options.onError === "function" ? options.onError : () => void 0;
  const result = useAsyncAbortable(
    (signal) => {
      return import_client_app_settings.appSettingsObjectsClient.getAppSettingsObjects({
        ...params,
        abortSignal: signal
      });
    },
    [JSON.stringify(params)],
    {
      executeOnMount: options.autoFetch,
      executeOnUpdate: options.autoFetchOnUpdate,
      onError
    }
  );
  return getResult4(result);
}
function useEffectivePermissions(params, options = { autoFetch: true, autoFetchOnUpdate: true }) {
  const onError = typeof options.onError === "function" ? options.onError : () => void 0;
  const result = useAsyncAbortable(
    (signal) => {
      return import_client_app_settings.appSettingsObjectsClient.resolveEffectivePermissions({
        ...params,
        abortSignal: signal
      });
    },
    [JSON.stringify(params)],
    {
      executeOnMount: options.autoFetch,
      executeOnUpdate: options.autoFetchOnUpdate,
      onError
    }
  );
  return getResult4(result);
}
function useDeleteSettings() {
  const executeParams = (0, import_react4.useRef)();
  const execute = async (params) => {
    executeParams.current = params;
    await result.execute();
  };
  const result = useAsyncCallback(() => {
    if (executeParams.current) {
      return import_client_app_settings.appSettingsObjectsClient.deleteAppSettingsObjectByObjectId({
        ...executeParams.current
      });
    }
  });
  return getCallbackResult3(result, execute);
}
function useUpdateSettings() {
  const executeParams = (0, import_react4.useRef)();
  const execute = async (params) => {
    executeParams.current = params;
    await result.execute();
  };
  const result = useAsyncCallback(() => {
    if (executeParams.current) {
      return import_client_app_settings.appSettingsObjectsClient.putAppSettingsObjectByObjectId({ ...executeParams.current });
    }
  });
  return getCallbackResult3(result, execute);
}
function useCreateSettings() {
  const executeParams = (0, import_react4.useRef)();
  const execute = async (params) => {
    executeParams.current = params;
    await result.execute();
  };
  const result = useAsyncCallback(() => {
    if (executeParams.current) {
      return import_client_app_settings.appSettingsObjectsClient.postAppSettingsObject({ ...executeParams.current });
    }
  });
  return getCallbackResult3(result, execute);
}
function getCallbackResult3(result, execute) {
  const error = result.error;
  return {
    execute,
    data: result.result,
    error: error ? result.error : void 0,
    errorDetails: error?.body?.error,
    isError: error ? true : false,
    isSuccess: !error && !result.loading && result.result,
    isLoading: result.loading,
    status: result.status
  };
}
function getResult4(result) {
  const error = result.error;
  return {
    data: result.result,
    error: error ? result.error : void 0,
    errorDetails: error?.body?.error,
    isError: error ? true : false,
    isLoading: result.loading,
    isSuccess: !error && !result.loading && result.result,
    status: result.status,
    refetch: result.execute,
    cancel: result.cancel
  };
}

// packages/util/react-hooks/src/useSettingsV2.ts
var import_client_app_settings_v2 = require("@dynatrace-sdk/client-app-settings-v2");
var import_react5 = require("react");
function useSettingsV2(params, options = { autoFetch: true, autoFetchOnUpdate: true }) {
  const onError = typeof options.onError === "function" ? options.onError : () => void 0;
  const result = useAsyncAbortable(
    (signal) => {
      return import_client_app_settings_v2.appSettingsObjectsClient.getEffectiveAppSettingsValues({
        ...params,
        abortSignal: signal
      });
    },
    [JSON.stringify(params)],
    {
      executeOnMount: options.autoFetch,
      executeOnUpdate: options.autoFetchOnUpdate,
      onError
    }
  );
  return getResult5(result);
}
function useSettingsObjectsV2(params, options = { autoFetch: true, autoFetchOnUpdate: true }) {
  const onError = typeof options.onError === "function" ? options.onError : () => void 0;
  const result = useAsyncAbortable(
    (signal) => {
      return import_client_app_settings_v2.appSettingsObjectsClient.getAppSettingsObjects({
        ...params,
        abortSignal: signal
      });
    },
    [JSON.stringify(params)],
    {
      executeOnMount: options.autoFetch,
      executeOnUpdate: options.autoFetchOnUpdate,
      onError
    }
  );
  return getResult5(result);
}
function useEffectivePermissionsV2(params, options = { autoFetch: true, autoFetchOnUpdate: true }) {
  const onError = typeof options.onError === "function" ? options.onError : () => void 0;
  const result = useAsyncAbortable(
    (signal) => {
      return import_client_app_settings_v2.appSettingsObjectsClient.resolveEffectivePermissions({
        ...params,
        abortSignal: signal
      });
    },
    [JSON.stringify(params)],
    {
      executeOnMount: options.autoFetch,
      executeOnUpdate: options.autoFetchOnUpdate,
      onError
    }
  );
  return getResult5(result);
}
function useDeleteSettingsV2() {
  const executeParams = (0, import_react5.useRef)();
  const execute = async (params) => {
    executeParams.current = params;
    await result.execute();
  };
  const result = useAsyncCallback(() => {
    if (executeParams.current) {
      return import_client_app_settings_v2.appSettingsObjectsClient.deleteAppSettingsObjectByObjectId({
        ...executeParams.current
      });
    }
  });
  return getCallbackResult4(result, execute);
}
function useUpdateSettingsV2() {
  const executeParams = (0, import_react5.useRef)();
  const execute = async (params) => {
    executeParams.current = params;
    await result.execute();
  };
  const result = useAsyncCallback(() => {
    if (executeParams.current) {
      return import_client_app_settings_v2.appSettingsObjectsClient.putAppSettingsObjectByObjectId({
        ...executeParams.current
      });
    }
  });
  return getCallbackResult4(result, execute);
}
function useCreateSettingsV2() {
  const executeParams = (0, import_react5.useRef)();
  const execute = async (params) => {
    executeParams.current = params;
    await result.execute();
  };
  const result = useAsyncCallback(() => {
    if (executeParams.current) {
      return import_client_app_settings_v2.appSettingsObjectsClient.postAppSettingsObject({
        ...executeParams.current
      });
    }
  });
  return getCallbackResult4(result, execute);
}
function useTransferOwnershipV2() {
  const executeParams = (0, import_react5.useRef)();
  const execute = async (params) => {
    executeParams.current = params;
    await result.execute();
  };
  const result = useAsyncCallback(() => {
    if (executeParams.current) {
      return import_client_app_settings_v2.appSettingsObjectsClient.postAppSettingsOwnershipByObjectId({
        ...executeParams.current
      });
    }
  });
  return getCallbackResult4(result, execute);
}
function useAccessorPermissionsV2(params, options = { autoFetch: true, autoFetchOnUpdate: true }) {
  const onError = typeof options.onError === "function" ? options.onError : () => void 0;
  const result = useAsyncAbortable(
    (signal) => {
      return import_client_app_settings_v2.appSettingsObjectsClient.getAppSettingsPermissionByObjectIdAndAccessorId({
        ...params,
        abortSignal: signal
      });
    },
    [JSON.stringify(params)],
    {
      executeOnMount: options.autoFetch,
      executeOnUpdate: options.autoFetchOnUpdate,
      onError
    }
  );
  return getResult5(result);
}
function useUpdateAccessorPermissionsV2() {
  const executeParams = (0, import_react5.useRef)();
  const execute = async (params) => {
    executeParams.current = params;
    await result.execute();
  };
  const result = useAsyncCallback(() => {
    if (executeParams.current) {
      return import_client_app_settings_v2.appSettingsObjectsClient.putAppSettingsPermissionByObjectIdAndAccessorId({
        ...executeParams.current
      });
    }
  });
  return getCallbackResult4(result, execute);
}
function useDeleteAccessorPermissionsV2() {
  const executeParams = (0, import_react5.useRef)();
  const execute = async (params) => {
    executeParams.current = params;
    await result.execute();
  };
  const result = useAsyncCallback(() => {
    if (executeParams.current) {
      return import_client_app_settings_v2.appSettingsObjectsClient.deleteAppSettingsPermissionByObjectIdAndAccessorId({
        ...executeParams.current
      });
    }
  });
  return getCallbackResult4(result, execute);
}
function usePermissionsV2(params, options = { autoFetch: true, autoFetchOnUpdate: true }) {
  const onError = typeof options.onError === "function" ? options.onError : () => void 0;
  const result = useAsyncAbortable(
    (signal) => {
      return import_client_app_settings_v2.appSettingsObjectsClient.getAppSettingsPermissionsByObjectId({
        ...params,
        abortSignal: signal
      });
    },
    [JSON.stringify(params)],
    {
      executeOnMount: options.autoFetch,
      executeOnUpdate: options.autoFetchOnUpdate,
      onError
    }
  );
  return getResult5(result);
}
function useCreatePermissionsV2() {
  const executeParams = (0, import_react5.useRef)();
  const execute = async (params) => {
    executeParams.current = params;
    await result.execute();
  };
  const result = useAsyncCallback(() => {
    if (executeParams.current) {
      return import_client_app_settings_v2.appSettingsObjectsClient.postAppSettingsPermissionByObjectId({
        ...executeParams.current
      });
    }
  });
  return getCallbackResult4(result, execute);
}
function useAllUsersPermissionsV2(params, options = { autoFetch: true, autoFetchOnUpdate: true }) {
  const onError = typeof options.onError === "function" ? options.onError : () => void 0;
  const result = useAsyncAbortable(
    (signal) => {
      return import_client_app_settings_v2.appSettingsObjectsClient.getAppSettingsAllUsersPermissionByObjectId({
        ...params,
        abortSignal: signal
      });
    },
    [JSON.stringify(params)],
    {
      executeOnMount: options.autoFetch,
      executeOnUpdate: options.autoFetchOnUpdate,
      onError
    }
  );
  return getResult5(result);
}
function useUpdateAllUsersPermissionsV2() {
  const executeParams = (0, import_react5.useRef)();
  const execute = async (params) => {
    executeParams.current = params;
    await result.execute();
  };
  const result = useAsyncCallback(() => {
    if (executeParams.current) {
      return import_client_app_settings_v2.appSettingsObjectsClient.putAppSettingsAllUsersPermissionByObjectId({
        ...executeParams.current
      });
    }
  });
  return getCallbackResult4(result, execute);
}
function useDeleteAllUsersPermissionsV2() {
  const executeParams = (0, import_react5.useRef)();
  const execute = async (params) => {
    executeParams.current = params;
    await result.execute();
  };
  const result = useAsyncCallback(() => {
    if (executeParams.current) {
      return import_client_app_settings_v2.appSettingsObjectsClient.deleteAppSettingsAllUsersPermissionByObjectId({
        ...executeParams.current
      });
    }
  });
  return getCallbackResult4(result, execute);
}
function getCallbackResult4(result, execute) {
  const error = result.error;
  return {
    execute,
    data: result.result,
    error: error ? result.error : void 0,
    errorDetails: error?.body?.error,
    isError: error ? true : false,
    isSuccess: !error && !result.loading && result.result,
    isLoading: result.loading,
    status: result.status
  };
}
function getResult5(result) {
  const error = result.error;
  return {
    data: result.result,
    error: error ? result.error : void 0,
    errorDetails: error?.body?.error,
    isError: error ? true : false,
    isLoading: result.loading,
    isSuccess: !error && !result.loading && result.result,
    status: result.status,
    refetch: result.execute,
    cancel: result.cancel
  };
}

// packages/util/react-hooks/src/use-dql/useDql.ts
var import_react_query2 = require("@tanstack/react-query");
var import_react7 = require("react");

// packages/util/react-hooks/src/use-dql/query.ts
var import_client_query2 = require("@dynatrace-sdk/client-query");
var import_http_client = require("@dynatrace-sdk/http-client");
var queryExecutionClient2 = new import_client_query2.QueryExecutionClient(import_http_client.httpClient, { transformDates: false });
async function executeQuery(params, signal, controller) {
  try {
    return await queryExecutionClient2.queryExecute({
      body: params,
      abortSignal: signal,
      ...params
    });
  } catch (error) {
    controller?.abort();
    throw error;
  }
}
async function pollQuery(requestToken, params, controller) {
  try {
    return await queryExecutionClient2.queryPoll({
      requestToken,
      ...params
    });
  } catch (error) {
    controller?.abort();
    throw error;
  }
}
async function cancelQuery(requestToken, params, controller) {
  controller?.abort();
  return await queryExecutionClient2.queryCancel({
    requestToken,
    ...params
  });
}

// packages/util/react-hooks/src/use-dql/utils.ts
var import_client_query3 = require("@dynatrace-sdk/client-query");
var delay2 = (ms, value, signal) => new Promise((resolve, reject) => {
  const listener = () => {
    clearTimeout(timer);
    reject(value);
  };
  const timer = setTimeout(() => {
    signal?.removeEventListener("abort", listener);
    resolve(value);
  }, ms);
  signal?.addEventListener("abort", listener);
});
function isTooManyRequestsError(error) {
  return (0, import_client_query3.isClientRequestError)(error) && error.response.status === 429;
}
function isString(val) {
  return typeof val === "string" || val instanceof String;
}
async function promiseStatus(promise) {
  const referenceObject = { name: "Victor" };
  const value = await Promise.race([promise, referenceObject]);
  return value === referenceObject ? "pending" : "fulfilled";
}

// packages/util/react-hooks/src/use-dql/context.ts
var import_react6 = require("react");
var DqlQueryParamsContext = (0, import_react6.createContext)({});
function DqlQueryParamsProvider(props) {
  const { children, ...params } = props;
  return (0, import_react6.createElement)(
    DqlQueryParamsContext.Provider,
    {
      value: params
    },
    children
  );
}

// packages/util/react-hooks/src/use-dql/query-client.ts
var import_react_query = require("@tanstack/react-query");
var defaultQueryOptions = {
  staleTime: 6e4,
  pollRate: 1e3,
  enabled: true
};
function getDefaultQueryClientConfig() {
  return {
    defaultOptions: {
      queries: {
        refetchOnMount: false,
        refetchOnWindowFocus: false,
        refetchOnReconnect: false,
        refetchInterval: false,
        staleTime: 6e4,
        retry: false
      }
    }
  };
}
var queryClient = new import_react_query.QueryClient(getDefaultQueryClientConfig());

// packages/util/react-hooks/src/use-dql/useDql.ts
var IS_POLLING_DONE_INTERVAL = 500;
var IS_POLLING_DONE_TIMEOUT = 5e3;
function getQueryOptions(opts, ctxOpts = {}) {
  return {
    ...defaultQueryOptions,
    ...ctxOpts,
    ...opts
  };
}
function normalizeQueryParams(query, ctxParams) {
  const queryString = isString(query) ? query : query.query;
  const params = isString(query) ? {} : query;
  return {
    ...ctxParams,
    ...params,
    query: queryString
  };
}
function getQueryKey(queryParams) {
  const { query, ...params } = queryParams;
  return [query, JSON.stringify(params)];
}
function getQueryClientOptions(opts) {
  return {
    staleTime: opts.staleTime,
    refetchInterval: opts.refetchInterval,
    enabled: opts.enabled
  };
}
function useDql(query, options = {}) {
  const queryParamsContext = (0, import_react7.useContext)(DqlQueryParamsContext);
  const [progress, setProgress] = (0, import_react7.useState)(0);
  const [state, setState] = (0, import_react7.useState)("NOT_STARTED");
  const [data, setData] = (0, import_react7.useState)(void 0);
  const q = (0, import_react7.useMemo)(
    () => normalizeQueryParams(query, queryParamsContext),
    [query, queryParamsContext]
  );
  const queryOpts = (0, import_react7.useMemo)(() => getQueryOptions(options), [options]);
  const queryKey = (0, import_react7.useMemo)(() => getQueryKey(q), [q]);
  const queryClientOpts = (0, import_react7.useMemo)(() => getQueryClientOptions(queryOpts), [queryOpts]);
  const cancel = (0, import_react7.useCallback)(async () => {
    await queryClient.cancelQueries({ queryKey });
  }, [queryClient, queryKey]);
  const queryResult = (0, import_react_query2.useQuery)(
    {
      // eslint-disable-next-line @tanstack/query/exhaustive-deps
      queryKey,
      ...queryClientOpts,
      queryFn: async ({ signal }) => {
        setState("NOT_STARTED");
        setProgress(0);
        const removeHandlersController = new AbortController();
        const cancelExecuteController = new AbortController();
        let executeQueryResponse = null;
        let timeout = 1;
        while (!executeQueryResponse?.result && !executeQueryResponse?.requestToken) {
          try {
            executeQueryResponse = await executeQuery(q, signal, removeHandlersController);
          } catch (error) {
            if (isTooManyRequestsError(error)) {
              await delay2(Math.min(timeout++ ** 2, 30) * 1e3, void 0, signal);
            } else {
              throw error;
            }
          }
        }
        if (executeQueryResponse?.requestToken) {
          signal.addEventListener(
            "abort",
            async () => {
              const response = await cancelQuery(
                executeQueryResponse.requestToken,
                q,
                removeHandlersController
              );
              setProgress(response?.progress ?? 0);
              setState(response?.state ?? "CANCELLED");
            },
            { signal: cancelExecuteController.signal }
          );
          addEventListener(
            "beforeunload",
            async () => {
              if (queryClient.isFetching({ queryKey })) {
                removeHandlersController.abort();
                navigator.sendBeacon(
                  `/platform/storage/query/v1/query:cancel?request-token=${encodeURIComponent(
                    executeQueryResponse.requestToken
                  )}`
                );
              }
            },
            { signal: removeHandlersController.signal }
          );
          addEventListener(
            "visibilitychange",
            async () => {
              if (document.hidden && queryClient.isFetching({ queryKey })) {
                await cancel();
              }
            },
            { signal: removeHandlersController.signal }
          );
        }
        if (executeQueryResponse?.progress && executeQueryResponse?.progress !== progress) {
          setProgress(executeQueryResponse.progress ?? 0);
        }
        if (executeQueryResponse?.state && executeQueryResponse?.state !== state) {
          setState(executeQueryResponse.state);
        }
        if (!(executeQueryResponse?.state === "RUNNING" || executeQueryResponse?.state === "NOT_STARTED" || executeQueryResponse?.result === void 0)) {
          return executeQueryResponse?.result;
        }
        let pollQueryResponse = null;
        while (!signal.aborted && executeQueryResponse.requestToken && (pollQueryResponse === null || pollQueryResponse.state === "RUNNING" || pollQueryResponse.state === "NOT_STARTED")) {
          await delay2(queryOpts.pollRate, void 0, signal);
          const pollPromise = pollQuery(
            executeQueryResponse.requestToken,
            q,
            removeHandlersController
          );
          if (!cancelExecuteController.signal.aborted) {
            cancelExecuteController.abort();
            signal.addEventListener("abort", async () => {
              setProgress(0);
              setState("CANCELLED");
              const isQueryCompleted = await new Promise((res) => {
                const interval = setInterval(async () => {
                  if (pollQueryResponse?.state === "SUCCEEDED") {
                    clearInterval(interval);
                    clearTimeout(timeout2);
                    res(true);
                  }
                  const isPollingFinished = await promiseStatus(pollPromise) === "fulfilled";
                  if (isPollingFinished && pollQueryResponse?.state !== "SUCCEEDED") {
                    clearInterval(interval);
                    clearTimeout(timeout2);
                    res(false);
                  }
                }, IS_POLLING_DONE_INTERVAL);
                const timeout2 = setTimeout(() => {
                  clearInterval(interval);
                  res(false);
                }, IS_POLLING_DONE_TIMEOUT);
              });
              if (!isQueryCompleted) {
                await cancelQuery(executeQueryResponse.requestToken, q, removeHandlersController);
              }
            });
          }
          pollQueryResponse = await pollPromise;
          const pollQueryResult = pollQueryResponse.result;
          if (q.enablePreview && pollQueryResult && pollQueryResponse.state !== "SUCCEEDED") {
            setData(pollQueryResult);
          }
          if (!signal.aborted && pollQueryResponse?.progress) {
            setProgress(pollQueryResponse.progress ?? 0);
          }
          if (!signal.aborted && pollQueryResponse?.state) {
            setState(pollQueryResponse.state);
          }
        }
        removeHandlersController.abort();
        return pollQueryResponse?.result;
      }
    },
    queryClient
  );
  const refetch = (0, import_react7.useCallback)(
    async (options2) => {
      if ((queryResult.isStale || !queryOpts.enabled) && !queryResult.isFetching) {
        return await forceRefetch(options2);
      }
      const baseReturnValue2 = {
        state,
        progress,
        cancel,
        data,
        error: queryResult.error,
        isSuccess: queryResult.isSuccess,
        isError: queryResult.isError,
        isPending: queryResult.isPending,
        isLoading: queryResult.isLoading,
        isLoadingError: queryResult.isLoadingError,
        isRefetchError: queryResult.isRefetchError,
        isFetching: queryResult.isFetching,
        isFetched: queryResult.isFetched,
        isStale: queryResult.isStale,
        refetch,
        forceRefetch
      };
      return baseReturnValue2;
    },
    [queryResult.isStale, queryOpts.enabled, queryResult.isFetching, queryResult.refetch]
  );
  const forceRefetch = (0, import_react7.useCallback)(
    async (options2) => {
      const refetchResult = await queryResult.refetch(options2);
      const baseReturnValue2 = {
        state,
        progress,
        cancel,
        data,
        error: refetchResult.error,
        isSuccess: refetchResult.isSuccess,
        isError: refetchResult.isError,
        isPending: refetchResult.isPending,
        isLoading: refetchResult.isLoading,
        isLoadingError: refetchResult.isLoadingError,
        isRefetchError: refetchResult.isRefetchError,
        isFetching: refetchResult.isFetching,
        isFetched: refetchResult.isFetched,
        isStale: refetchResult.isStale,
        refetch,
        forceRefetch
      };
      return baseReturnValue2;
    },
    [queryResult.refetch]
  );
  (0, import_react7.useEffect)(() => {
    if (queryResult.data)
      setData(queryResult.data);
  }, [queryResult.data]);
  const baseReturnValue = {
    state,
    progress,
    cancel,
    data,
    error: queryResult.error,
    isSuccess: queryResult.isSuccess,
    isError: queryResult.isError,
    isPending: queryResult.isPending,
    isLoading: queryResult.isLoading,
    isLoadingError: queryResult.isLoadingError,
    isRefetchError: queryResult.isRefetchError,
    isFetching: queryResult.isFetching,
    isFetched: queryResult.isFetched,
    isStale: queryResult.isStale,
    refetch,
    forceRefetch
  };
  return baseReturnValue;
}
