import { AppSettingsValue } from './app-settings-value';
/**
 * Configuration of a new settings object.
 */
export interface AppSettingsObjectCreate {
    /**
     * The schema on which the object is based.
     */
    schemaId: string;
    /**
     * The value of the setting.
     *
     *  It defines the actual values of settings' parameters.
     *
     * The actual content depends on the object's schema.
     */
    value: AppSettingsValue;
    /**
     * The position of the new object. The new object will be added after the specified one.
     *
     * If `null`, the new object will be placed in the last position.
     *
     * If set to empty string, the new object will be placed in the first position.
     *
     * Only applicable for objects based on schemas with ordered objects (schema's `ordered` parameter is set to `true`).
     */
    insertAfter?: string;
}
