import { AppSettingsObject } from './app-settings-object';
import { ErrorIncomplete } from './error-incomplete';
/**
 * A list of settings objects.
 */
export interface AppSettingsObjectsList {
    /**
     * The total number of entries in the result.
     */
    totalCount: number;
    /**
     * The number of entries per page.
     */
    pageSize: number;
    /**
     * The cursor for the next page of results. Has the value of `null` on the last page.
     *
     * Use it in the **nextPageKey** query parameter to obtain subsequent pages of the result.
     */
    nextPageKey?: string;
    /**
     * A list of settings objects.
     */
    items: AppSettingsObject[];
    /**
     * Error object for an incomplete response
     */
    error?: ErrorIncomplete;
}
