/**
 * Modification information about the setting.
 */
export interface ModificationInfo {
    /**
     * The unique identifier of the user who created the setting.
     */
    createdBy?: string;
    /**
     * Timestamp when the setting was created in ISO 8601 format (yyyy-MM-dd'T'HH:mm:ss.SSS'Z')
     */
    createdTime?: Date;
    /**
     * The unique identifier of the user who performed the most recent modification.
     */
    lastModifiedBy?: string;
    /**
     * Timestamp when the setting was last modified in ISO 8601 format (yyyy-MM-dd'T'HH:mm:ss.SSS'Z')
     */
    lastModifiedTime?: Date;
}
