/**
 * The additional modification details for this settings object.
 */
export interface Modifications {
    /**
     * If non-moveable settings object is in the first group of non-moveable settings, or in the last (start or end of list).
     */
    first?: boolean;
    /**
     * Property paths which are modifiable, regardless if the `write` operation is allowed.
     */
    modifiablePaths: string[];
    /**
     * If settings object can be moved/reordered. Only applicable for ordered list schema.
     */
    movable?: boolean;
    /**
     * Property paths which are not modifiable, even if the `write` operation is allowed.
     */
    nonModifiablePaths: string[];
}
