import { AnalyzerDimensionalDataValue } from './analyzer-dimensional-data-value';
import { DimensionQuery } from './dimension-query';
/**
 * A list of resolved dimensional data.
 */
export interface AnalyzerDimensionalData {
    /**
     * A query for dimensional data such as timeseries, entities, or logs.
     */
    query: DimensionQuery;
    /**
     * The resolved value of the dimensional query.
     */
    value: AnalyzerDimensionalDataValue;
    /**
     * The type of the dimensional query.
     */
    type: 'entityId' | 'timeseriesArray';
}
