import { AnalyzerResult } from './analyzer-result';
/**
 * Result of the analyzer execution.
 */
export interface AnalyzerExecuteResult {
    /**
     * The request token is returned when starting a long-running analyzer execution.
     * It can be used to do follow-up operations like polling and cancelling.
     */
    requestToken?: string;
    /**
     * Time-to-live until the result is not available anymore.
     */
    ttlInSeconds?: number;
    result: AnalyzerResult;
}
