import { AnalyzerDefinition } from './analyzer-definition';
/**
 * The list of available analyzers.
 */
export interface AnalyzerQueryResult {
    /**
     * The key that should be used to do follow-up requests, fetching the remaining analyzers.
     * If the last page is reached or all analyzers are already listed, this field is omitted.
     */
    nextPageKey?: string;
    /**
     * The total amount of analyzers available opposed to the current page size.
     */
    totalCount: number;
    analyzers: AnalyzerDefinition[];
}
