export interface Timeframe {
    /**
     * Specify the start time in either absolute or relative format.
     * For absolute format, use the ISO 8601 format (yyyy-MM-ddTHH:mm:ssZ).
     * For relative format, use 'now' for the current time or apply an offset with the available units: 's' for seconds, 'm' for minutes, 'h' for hours, and 'd' for days.
     * For example, use 'now-2h' or '-2h' for a relative offset of 2 hours.
     */
    startTime: string;
    /**
     * Specify the end time in either absolute or relative format.
     * For absolute format, use the ISO 8601 format (yyyy-MM-ddTHH:mm:ssZ).
     * For relative format, use 'now' for the current time or apply an offset with the available units: 's' for seconds, 'm' for minutes, 'h' for hours, and 'd' for days.
     * For example, use 'now-2h' or '-2h' for a relative offset of 2 hours. If not specified, defaults to now.
     */
    endTime?: string;
}
