import { SsoEntity } from './sso-entity';
/**
 * Input required to create a direct-share.
 */
export interface CreateDirectShare {
    /**
     * Document id.
     */
    documentId: string;
    /**
     * Specifies which permissions shall be granted via the share: - `read` - grants permission to read the document, but not to update or delete it. - `read-write` - grants permission to read and update the document, but not to delete it.
     */
    access: string;
    /**
     * An array of sso-users (sso-ids). These users will immediately get access to the document. Can be empty.
     */
    recipients: SsoEntity[];
}
