/**
 * The locking details of the document.
 */
export interface DocumentLockDetails {
    /**
     * The user that currently owns the lock.
     */
    lockedBy?: string;
    /**
     * Document is locked or not.
     */
    isLocked?: boolean;
    /**
     * Document is locked by another user or not.
     */
    isLockedByAnotherUser: boolean;
    /**
     * Latest version of the document.
     */
    documentVersion: number;
}
