/**
 * Confirmation of claiming an environment-share.
 */
export interface EnvironmentShareClaimResult {
    /**
     * The shared document's id.
     */
    documentId: string;
    /**
     * The shared document's type.
     */
    documentType: string;
    /**
     * Indicates which operations you may apply to this document. For example, if you own the document, this array contains the values ['read', 'write', 'delete'].
     *
     * - `read` - you may read, but not update or delete it.
     * - `write` - you may update, but not read or delete it.
     * - `delete` - you may delete, but not read or update it.
     */
    access: string[];
}
