/**
 * Info related to creation and modification of the entity.
 */
export interface ModificationInfo {
    /**
     * User who created this entity.
     */
    createdBy: string;
    /**
     * Creation time (in notation as defined by RFC 3339, section 5.6).
     */
    createdTime: Date;
    /**
     * User who last modified this entity (metadata or content).
     */
    lastModifiedBy: string;
    /**
     * Time of last modification (in notation as defined by RFC 3339, section 5.6).
     */
    lastModifiedTime: Date;
}
