import { SnapshotMetadata } from './snapshot-metadata';
/**
 * Envelope object for a list of snapshots of a document.
 */
export interface SnapshotList {
    snapshots: SnapshotMetadata[];
    /**
     * Use this as `page-key` query param to get the next page. If the list was paginated, and there are more results available, this parameter will be returned.
     */
    nextPageKey?: string;
    /**
     * The total amount of matching results for this query, as if no pagination would have been applied.
     */
    totalCount: number;
}
