import { DeletionInfo } from './deletion-info';
/**
 * A document which has been deleted and now lives in the trash.
 */
export interface TrashDocumentListEntry {
    /**
     * Id of the deleted document.
     */
    id: string;
    /**
     * Name of the deleted document.
     */
    name: string;
    /**
     * Type of the deleted document.
     */
    type: string;
    /**
     * Info related to the deletion of the entity.
     */
    deletionInfo: DeletionInfo;
}
