import { DeletionInfo } from './deletion-info';
import { ModificationInfo } from './modification-info';
/**
 * A document which has been moved to the trash.
 */
export interface TrashDocument {
    /**
     * Id of the deleted document.
     */
    id: string;
    /**
     * Name of the deleted document.
     */
    name: string;
    /**
     * Type of the deleted document.
     */
    type: string;
    /**
     * Version of the deleted document.
     */
    version: number;
    /**
     * Owner of the deleted document.
     */
    owner: string;
    /**
     * Info related to creation and modification of the entity.
     */
    modificationInfo: ModificationInfo;
    /**
     * Info related to the deletion of the entity.
     */
    deletionInfo: DeletionInfo;
}
