/**
 * Available options for react-hooks
 */
export type HookOptions = {
    /** If set to true, the hook will execute the query immediately. If set to false, the query only executes when calling refetch. */
    autoFetch: boolean;
    /** If set to true, the hook will execute the query on a component update. If set to false, it is not executed on update. */
    autoFetchOnUpdate: boolean;
    onError?: (error: Error) => void;
};
