import { PropsWithChildren } from 'react';
import { DqlQueryParams } from './types';
/**
 * @interface
 */
export type DqlQueryParamsContextProps = Omit<DqlQueryParams, 'query'>;
/**
 * Context storing Dql query params.
 */
export declare const DqlQueryParamsContext: import("react").Context<DqlQueryParamsContextProps>;
/**
 * Provider component for Dql query params context to use with the `useDql` hook.
 */
export declare function DqlQueryParamsProvider(props: PropsWithChildren<DqlQueryParamsContextProps>): import("react").FunctionComponentElement<import("react").ProviderProps<DqlQueryParamsContextProps>>;
