import { ResultRecord } from '@dynatrace-sdk/client-query';
import { DqlQueryParams, UseDqlResult, UseDqlOptions } from './types';
/**
 * React hook for executing DQL queries.
 *
 * @template T Type of records returned by Grail.
 * @param {string | DqlQueryParams} query Query and enrich options that will be executed.
 * @param {UseDqlOptions} [options={staleTime: 60000, pollRate: 1000}] Additional options for the React hook.
 * @returns {UseDqlResult} The result of the query, variables indicating the current state and functions to cancel or refetch the query.
 */
export declare function useDql<T = ResultRecord>(query: string | DqlQueryParams, options?: UseDqlOptions): UseDqlResult<T>;
